BEGIN
   dbms_plsql_code_coverage.create_coverage_tables (force_it => TRUE);
END;
/


CREATE OR REPLACE PROCEDURE run_tests (driver_in IN INTEGER)
IS
BEGIN
   IF driver_in = 1
   THEN
      DBMS_OUTPUT.put_line ('1');
   ELSE
      DBMS_OUTPUT.put_line ('Not 1');
   END IF;

   FOR indx IN 1 .. driver_in
   LOOP
      DBMS_OUTPUT.put_line ('driven ' || indx);
   END LOOP;
END;
/

BEGIN
   dbms_plsql_code_coverage.start_coverage ('Test Run 17');
   run_tests (1);
   run_tests (3);
   dbms_plsql_code_coverage.stop_coverage;
END;
/

  SELECT u.owner,
         u.name,
         u.TYPE,
         ROUND (SUM (b.covered) / COUNT (b.block) * 100) pct_covered
    FROM dbmspcc_blocks b, dbmspcc_units u, dbmspcc_runs r
   WHERE     u.object_id = b.object_id
         AND r.run_comment = 'Test Run 17'
         AND r.run_id = u.run_id
GROUP BY u.owner, u.name, u.TYPE
/