/* Unfinished
CREATE OR REPLACE PACKAGE restaurant_pkg
AS
   TYPE item_list_t IS TABLE OF VARCHAR2 (30);

   PROCEDURE eat_that (items_in              IN item_list_t,
                       make_it_spicy_in_in   IN BOOLEAN);
END;


CREATE OR REPLACE PACKAGE BODY restaurant_pkg
AS
   PROCEDURE eat_that (items_in              IN item_list_t,
                       make_it_spicy_in_in   IN BOOLEAN)
   IS
   BEGIN
      FOR indx IN 1 .. items_in.COUNT
      LOOP
         DBMS_OUTPUT.put_line (
               CASE WHEN make_it_spicy_in_in THEN 'Spicy ' END
            || items_in (indx));
      END LOOP;
   END;
END;


DECLARE
   things       restaurant_pkg.item_list_t
                   := restaurant_pkg.item_list_t ('steak', 'quiche', 'eggplant');
   l_cursor     INTEGER := DBMS_SQL.open_cursor ();
   l_feedback   INTEGER;
BEGIN
   DBMS_SQL.parse (l_cursor,
                   'BEGIN restaurant_pkg.eat_that(:l, :s); END;',
                   DBMS_SQL.native);

   DBMS_SQL.bind_variable_pkg (l_cursor, 'l', restaurant_pkg.item_list_t);

   l_feedback := DBMS_SQL.execute (l_cursor);
END;
*/

/* From the PL/SQL dev team */

CREATE TABLE t
(
   c1   NUMBER,
   c2   NUMBER,
   c3   NUMBER,
   v4   NUMBER
)
/

DECLARE
/* Bind Boolean as IN */
   c_with_boolean   CONSTANT VARCHAR2 (2000)
      := q'[
    DECLARE 
       x BOOLEAN := :my_boolean;
    BEGIN
       IF (x) then
          DBMS_OUTPUT.PUT_LINE ('value of x = ' || 'true');
       ELSE
          DBMS_OUTPUT.PUT_LINE ('value of x = ' || 'false');
       END IF;
    END;]' ;

   dummy                     NUMBER;
   cur                       NUMBER;
BEGIN
   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, c_with_boolean, DBMS_SQL.native);
   DBMS_SQL.bind_variable (cur, 'my_boolean', TRUE);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.close_cursor (cur);
END;
/

CREATE TABLE tab (c1 VARCHAR2 (30));

-- boolean outbinds

CREATE OR REPLACE PROCEDURE dyn_sql_bool_tab_out (p2 IN BOOLEAN)
   AUTHID DEFINER 
AS
   p1      BOOLEAN := p2;
   str     VARCHAR2 (3000);
   dummy   NUMBER;
   cur     NUMBER;
BEGIN
   str := '
BEGIN
   IF ( :v1)
   THEN
      :v1 := FALSE;

      INSERT INTO tab VALUES (''first true'');
   ELSE
      :v1 := TRUE;

      INSERT INTO tab VALUES (''first false'');
   END IF;
END;';

   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable (cur, ':v1', p1);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.variable_value (cur, 'v1', p1);
   print_boolean (p1);
   DBMS_SQL.close_cursor (cur);

   IF (p1)
   THEN
      INSERT INTO tab
           VALUES ('then true');
   ELSE
      INSERT INTO tab
           VALUES ('then false');
   END IF;
END;
/

BEGIN
/* Test OUT binding of Booleans */

   dyn_sql_bool_tab_out (TRUE);

   FOR rec IN (SELECT * FROM tab)
   LOOP
      DBMS_OUTPUT.put_line (rec.c1);
   END LOOP;

   ROLLBACK;
   dyn_sql_bool_tab_out (FALSE);

   FOR rec IN (SELECT * FROM tab)
   LOOP
      DBMS_OUTPUT.put_line (rec.c1);
   END LOOP;

   ROLLBACK;
END;
/


DECLARE
/* Bind Boolean as OUT */
   v1      BOOLEAN := FALSE;
   str     VARCHAR2 (3000);
   dummy   NUMBER;
   cur     NUMBER;
BEGIN
   str := 'begin :v1 := true; end;';

   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable (cur, ':v1', v1);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.variable_value (cur, ':v1', v1);
   DBMS_SQL.close_cursor (cur);

   IF (v1)
   THEN
      DBMS_OUTPUT.put_line ('true');
   ELSE
      DBMS_OUTPUT.put_line ('false');
   END IF;
END dyn_sql_bool2;
/



CREATE OR REPLACE PACKAGE rec_t
   AUTHID DEFINER 
AS
   TYPE rec1 IS RECORD (n NUMBER);

   TYPE rec IS RECORD
   (
      n    NUMBER,
      n1   NUMBER
   );
END rec_t;
/

DECLARE
/* Bind record as IN */
   stmt_1   CONSTANT VARCHAR2 (2000)
      := q'[
DECLARE
   v2   rec_t.rec;
BEGIN
   v2 := :v1;
   DBMS_OUTPUT.put_line (
      'rec.n =  ' || v2.n || '  rec.n1 =  ' || v2.n1);
END;]' ;


   dummy             NUMBER;
   cur               NUMBER;
   v1                rec_t.rec;
BEGIN
   v1.n := 100;
   v1.n1 := 200;
   -- Notice, for DBMS_Sql, that it's bind by name rather than by position.
   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, stmt_1, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (cur, ':v1', v1);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.close_cursor (cur);
END dyn_sql_record1;
/

DECLARE
/* Bind record as OUT */
   v1      rec_t.rec;

   str     VARCHAR2 (3000);
   dummy   NUMBER;
   cur     NUMBER;
BEGIN
   str :='
DECLARE
   v2   rec_t.rec;
BEGIN
   v2.n := 300;
   v2.n1 := 400;
   :v1 := v2;
END;';

   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (cur, ':v1', v1);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.variable_value_pkg (cur, ':v1', v1);
   DBMS_SQL.close_cursor (cur);
   DBMS_OUTPUT.put_line ('rec.n =  ' || v1.n || '  rec.n1 =  ' || v1.n1);
END dyn_sql_record2;
/

CREATE OR REPLACE PACKAGE ty_pkg
   AUTHID DEFINER 
AS
   TYPE rec IS RECORD
   (
      n1   NUMBER,
      n2   NUMBER
   );

   TYPE trec IS TABLE OF rec
      INDEX BY BINARY_INTEGER;

   TYPE trect IS TABLE OF NUMBER;

   TYPE trecv IS VARRAY (100) OF NUMBER;
END ty_pkg;
/


DECLARE
/* Bind INDEX BY PLS_INTEGER collection as IN */
   dummy   NUMBER;
   cur     NUMBER;
   v1      ty_pkg.trec;
   str     VARCHAR2 (3000);
BEGIN
   v1 (1).n1 := 1000;
   v1 (1).n2 := 2000;
   
   str := q'[
DECLARE
   v   ty_pkg.trec;
BEGIN
   v := :v1;

   DBMS_OUTPUT.put_line (
      'rec.n =  ' || v (1).n1 || ' rec.n1 =  ' || v (1).n2);
END;]';

   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (cur, ':v1', v1);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.close_cursor (cur);
END dyn_sql_ibbi;
/



-- ibbi out binds

DECLARE
/* Bind INDEX BY PLS_INTEGER collection as OUT */
   dummy   NUMBER;
   cur     NUMBER;
   v1      ty_pkg.trec;
   v2      ty_pkg.trec;
   str     VARCHAR2 (3000);
BEGIN
   v1 (1).n1 := 1000;
   v1 (1).n2 := 2000;
   
   str :=
      q'[
DECLARE
   v1   ty_pkg.trec;
BEGIN
   v1 := :v1;
   v1 (1).n1 := 3000;
   v1 (1).n2 := 4000;
   DBMS_OUTPUT.put_line
      ('rec.n =  ' || :v1(1).n1||'  rec.n1 =  ' || :v1(1).n2);
   :v2 := v1; 
END;]';

   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (cur, ':v1', v1);
   DBMS_SQL.bind_variable_pkg (cur, ':v2', v2);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.variable_value_pkg (cur, ':v2', v2);
   DBMS_OUTPUT.put_line (
      'rec.n =  ' || v2 (1).n1 || '  rec.n1 =  ' || v2 (1).n2);
   DBMS_SQL.close_cursor (cur);
END dyn_sql_ibbi_2;
/



DECLARE
/* Bind nested table as IN */
   dummy   NUMBER;
   cur     NUMBER;
   v1      ty_pkg.trect;
   str     VARCHAR2 (3000);
BEGIN
   v1 := ty_pkg.trect (1000);
   
   str := q'[
DECLARE
   v   ty_pkg.trect;
BEGIN
   v := :v1;
   DBMS_OUTPUT.put_line ('n =  ' || v (1));
END;]';

   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (cur, ':v1', v1);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.close_cursor (cur);
END dyn_sql_nt;
/



-- nested table out binds

DECLARE
/* Bind a nested table as an OUT */
   dummy   NUMBER;
   cur     NUMBER;
   v1      ty_pkg.trect;
   v2      ty_pkg.trect;
   str     VARCHAR2 (3000);
BEGIN
   v1 := ty_pkg.trect (1000);
   
   str :='
DECLARE
   v1   ty_pkg.trect;
BEGIN
   v1 := :v1;
   v1 (1) := 2000;
   :v2 := v1;
END;';

   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (cur, ':v1', v1);
   DBMS_SQL.bind_variable_pkg (cur, ':v2', v2);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.variable_value_pkg (cur, ':v2', v2);
   DBMS_OUTPUT.put_line ('n =  ' || v2 (1));
   DBMS_SQL.close_cursor (cur);
END dyn_sql_nt_2;
/

DECLARE
/* Bind a varray as an IN */
   dummy   NUMBER;
   cur     NUMBER;
   v1      ty_pkg.trecv;
   str     VARCHAR2 (3000);
BEGIN
   v1 := ty_pkg.trecv (5000);
   
   str := q'[
DECLARE
   v   ty_pkg.trecv;
BEGIN
   v := :v1;
   DBMS_OUTPUT.put_line ('n =  ' || v (1));
END;]';

   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (cur, ':v1', v1);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.close_cursor (cur);
END dyn_sql_vr;
/

DECLARE
/* Bind a varray as an OUT */
   dummy   NUMBER;
   cur     NUMBER;
   v1      ty_pkg.trecv;
   v2      ty_pkg.trecv;
   str     VARCHAR2 (3000);
BEGIN
   v1 := ty_pkg.trecv (6000);
   
   str := '
DECLARE
   v1   ty_pkg.trecv;
BEGIN
   v1 := :v1;
   v1 (1) := 7000;
   :v2 := v1;
END;';

   cur := DBMS_SQL.open_cursor ();
   DBMS_SQL.parse (cur, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (cur, ':v1', v1);
   DBMS_SQL.bind_variable_pkg (cur, ':v2', v2);
   dummy := DBMS_SQL.execute (cur);
   DBMS_SQL.variable_value_pkg (cur, ':v2', v2);
   DBMS_OUTPUT.put_line ('n =  ' || v2 (1));
   DBMS_SQL.close_cursor (cur);
END dyn_sql_vr_2;
/

CREATE OR REPLACE PACKAGE pkg1
   AUTHID DEFINER 
IS
   TYPE nt_1 IS TABLE OF NUMBER;

   TYPE rec_nt_1 IS RECORD (nt nt_1);
END pkg1;
/

CREATE OR REPLACE PACKAGE pkg2
   AUTHID DEFINER 
IS
   TYPE var_1 IS VARRAY (20) OF NUMBER;

   TYPE rec_var_1 IS RECORD (var var_1);
END pkg2;
/

CREATE OR REPLACE PACKAGE pkg3
   AUTHID DEFINER 
IS
   TYPE ibbi_1 IS TABLE OF NUMBER
      INDEX BY PLS_INTEGER;

   TYPE rec_ibbi_1 IS RECORD (ibb ibbi_1);
END pkg3;
/

CREATE OR REPLACE PACKAGE pkg4
   AUTHID DEFINER 
IS
   TYPE ibbi_2 IS TABLE OF BOOLEAN
      INDEX BY PLS_INTEGER;

   TYPE rec_ibbi_2 IS RECORD (ibb ibbi_2);
END pkg4;
/

CREATE OR REPLACE PROCEDURE print_boolean (p1 BOOLEAN)
   AUTHID DEFINER 
AS
/* Helper routine */
BEGIN
   IF (p1)
   THEN
      DBMS_OUTPUT.put_line ('true');
   ELSE
      IF (p1 IS NULL)
      THEN
         DBMS_OUTPUT.put_line ('null');
      ELSE
         DBMS_OUTPUT.put_line ('false');
      END IF;
   END IF;
END;
/

CREATE OR REPLACE PACKAGE pkg5
   AUTHID DEFINER 
IS
   TYPE ibvc_1 IS TABLE OF NUMBER
      INDEX BY VARCHAR2 (10);

   TYPE rec_ibvc_1 IS RECORD (ivc ibvc_1);
END pkg5;
/

CREATE TABLE tab1
(
   n   NUMBER,
   m   NUMBER
);

CREATE OR REPLACE PACKAGE pkg6
   AUTHID DEFINER 
IS
   TYPE rec IS RECORD
   (
      p   PLS_INTEGER,
      b   BOOLEAN
   );

   TYPE rec1 IS RECORD
   (
      n   NUMBER,
      v   VARCHAR2 (20),
      p   PLS_INTEGER,
      b   BOOLEAN,
      r   rec
   );

   TYPE nt IS TABLE OF BOOLEAN;

   TYPE ibbi IS TABLE OF BOOLEAN
      INDEX BY PLS_INTEGER;

   TYPE var IS VARRAY (10) OF BOOLEAN;

   TYPE rec2 IS RECORD
   (
      n    nt,
      ib   ibbi,
      vr   var
   );
END pkg6;
/

CREATE OR REPLACE TYPE dyn_sql_obj_rec IS OBJECT
(
   n NUMBER,
   MEMBER FUNCTION func_rec_out_1
      RETURN NUMBER,
   MEMBER FUNCTION func_rec_out_2
      RETURN NUMBER,
   MEMBER FUNCTION func_rec_inout_1
      RETURN NUMBER,
   MEMBER FUNCTION func_rec_inout_2
      RETURN NUMBER
);
/

CREATE OR REPLACE TYPE BODY dyn_sql_obj_rec
IS
   MEMBER FUNCTION func_rec_out_1
      RETURN NUMBER
   IS
      v1        pkg6.rec1;
      str       VARCHAR2 (3000);
      l_cursor   INTEGER;
      l_ignore   INTEGER;
   BEGIN
   
      str := q'[
DECLARE
   v1   pkg6.rec1;
BEGIN
   v1.n := 1;
   v1.v := 'one';
   v1.p := -1;
   v1.b := TRUE;
   v1.r.p := 0;
   v1.r.b := FALSE;
   :v := v1;
END;]';

      l_cursor := DBMS_SQL.open_cursor;
      DBMS_SQL.parse (l_cursor, str, DBMS_SQL.native);
      DBMS_SQL.bind_variable_pkg (l_cursor, ':v', v1);
      l_ignore := DBMS_SQL.execute (l_cursor);
      DBMS_SQL.variable_value_pkg (l_cursor, ':v', v1);
      DBMS_SQL.close_cursor (l_cursor);
      DBMS_OUTPUT.put_line (v1.n);
      DBMS_OUTPUT.put_line (v1.v);
      DBMS_OUTPUT.put_line (v1.p);
      print_boolean (v1.b);
      DBMS_OUTPUT.put_line (v1.r.p);
      print_boolean (v1.r.b);
      RETURN 1;
   END;

   MEMBER FUNCTION func_rec_out_2
      RETURN NUMBER
   IS
      v2        pkg6.rec2;
      j         NUMBER := 1;
      str       VARCHAR2 (3000);
      l_cursor   INTEGER;
      l_ignore   INTEGER;
   BEGIN
      str := '
DECLARE
   v2   pkg6.rec2;
BEGIN
   v2.n := pkg6.nt (TRUE, FALSE, NULL);
   v2.ib (1) := TRUE;
   v2.ib (20) := FALSE;
   v2.ib (30000) := NULL;
   v2.vr := pkg6.var (TRUE, FALSE, NULL);
   :v := v2;
END;';

      l_cursor := DBMS_SQL.open_cursor;
      DBMS_SQL.parse (l_cursor, str, DBMS_SQL.native);
      DBMS_SQL.bind_variable_pkg (l_cursor, ':v', v2);
      l_ignore := DBMS_SQL.execute (l_cursor);
      DBMS_SQL.variable_value_pkg (l_cursor, ':v', v2);
      DBMS_SQL.close_cursor (l_cursor);

      LOOP
         print_boolean (v2.n (j));
         EXIT WHEN v2.n.NEXT (j) IS NULL;
         j := v2.n.NEXT (j);
      END LOOP;

      j := 1;

      LOOP
         print_boolean (v2.ib (j));
         EXIT WHEN v2.ib.NEXT (j) IS NULL;
         j := v2.ib.NEXT (j);
      END LOOP;

      j := 1;

      LOOP
         print_boolean (v2.vr (j));
         EXIT WHEN v2.vr.NEXT (j) IS NULL;
         j := v2.vr.NEXT (j);
      END LOOP;

      RETURN 1;
   END;

   MEMBER FUNCTION func_rec_inout_1
      RETURN NUMBER
   IS
      v1        pkg6.rec1;
      
      str CONSTANT VARCHAR2 (3000) := '
DECLARE
   v1   pkg6.rec1;
BEGIN
   v1 := :v;
   v1.b := FALSE;
   v1.r.b := TRUE;
   :v := v1;
END;';
      l_cursor   INTEGER;
      l_ignore   INTEGER;
   BEGIN
      v1.n := 1;
      v1.v := 'one';
      v1.p := -1;
      v1.b := TRUE;
      v1.r.p := 0;
      v1.r.b := FALSE;
      
      l_cursor := DBMS_SQL.open_cursor;
      DBMS_SQL.parse (l_cursor, str, DBMS_SQL.native);
      DBMS_SQL.bind_variable_pkg (l_cursor, ':v', v1);
      l_ignore := DBMS_SQL.execute (l_cursor);
      DBMS_SQL.variable_value_pkg (l_cursor, ':v', v1);
      DBMS_SQL.close_cursor (l_cursor);
      DBMS_OUTPUT.put_line (v1.n);
      DBMS_OUTPUT.put_line (v1.v);
      DBMS_OUTPUT.put_line (v1.p);
      print_boolean (v1.b);
      DBMS_OUTPUT.put_line (v1.r.p);
      print_boolean (v1.r.b);
      RETURN 1;
   END;

   MEMBER FUNCTION func_rec_inout_2
      RETURN NUMBER
   IS
      v2        pkg6.rec2;
      j         NUMBER := 1;
      str       VARCHAR2 (3000);
      l_cursor   INTEGER;
      l_ignore   INTEGER;
   BEGIN
      v2.n := pkg6.nt (TRUE, FALSE, NULL);
      v2.ib (1) := TRUE;
      v2.ib (20) := FALSE;
      v2.ib (30000) := NULL;
      v2.vr := pkg6.var (TRUE, FALSE, NULL);
      str := 'declare 
       v2 pkg6.rec2; 
     begin 
        v2 := :v; 
        v2.n(3) := true; 
        v2.ib(30000) := true; 
        v2.vr(3) := true; 
        :v := v2; 
     end;';
      l_cursor := DBMS_SQL.open_cursor;
      DBMS_SQL.parse (l_cursor, str, DBMS_SQL.native);
      DBMS_SQL.bind_variable_pkg (l_cursor, ':v', v2);
      l_ignore := DBMS_SQL.execute (l_cursor);
      DBMS_SQL.variable_value_pkg (l_cursor, ':v', v2);
      DBMS_SQL.close_cursor (l_cursor);

      LOOP
         print_boolean (v2.n (j));
         EXIT WHEN v2.n.NEXT (j) IS NULL;
         j := v2.n.NEXT (j);
      END LOOP;

      j := 1;

      LOOP
         print_boolean (v2.ib (j));
         EXIT WHEN v2.ib.NEXT (j) IS NULL;
         j := v2.ib.NEXT (j);
      END LOOP;

      j := 1;

      LOOP
         print_boolean (v2.vr (j));
         EXIT WHEN v2.vr.NEXT (j) IS NULL;
         j := v2.vr.NEXT (j);
      END LOOP;

      RETURN 1;
   END;
END;
/



CREATE OR REPLACE PACKAGE pkg7
   AUTHID DEFINER 
IS
   TYPE rec IS RECORD
   (
      p   PLS_INTEGER,
      b   BOOLEAN
   );

   TYPE rec1 IS RECORD
   (
      n   NUMBER,
      v   VARCHAR2 (20),
      p   PLS_INTEGER,
      b   BOOLEAN,
      r   rec
   );

   TYPE nt IS TABLE OF BOOLEAN;

   TYPE ibbi IS TABLE OF BOOLEAN
      INDEX BY PLS_INTEGER;

   TYPE var IS VARRAY (10) OF BOOLEAN;

   TYPE rec2 IS RECORD
   (
      n    nt,
      ib   ibbi,
      vr   var
   );
END pkg7;
/



CREATE OR REPLACE PACKAGE pkg8
   AUTHID DEFINER 
IS
   TYPE rec IS RECORD
   (
      p   PLS_INTEGER,
      b   BOOLEAN
   );

   TYPE rec1 IS RECORD
   (
      n   NUMBER,
      v   VARCHAR2 (20),
      p   PLS_INTEGER,
      b   BOOLEAN,
      r   rec
   );

   TYPE nt IS TABLE OF BOOLEAN;

   TYPE ibbi IS TABLE OF BOOLEAN
      INDEX BY PLS_INTEGER;

   TYPE var IS VARRAY (10) OF BOOLEAN;

   TYPE rec2 IS RECORD
   (
      n    nt,
      ib   ibbi,
      vr   var
   );
END pkg8;
/




CREATE TABLE tab2 (n NUMBER (3));


CREATE OR REPLACE PACKAGE pkg9 
   AUTHID DEFINER 
IS
   TYPE rec IS RECORD (n NUMBER);
END pkg9;
/



DECLARE
   v1        pkg1.rec_nt_1;
   j         NUMBER := 1;
   str  constant      VARCHAR2 (3000) := '
DECLARE
   v2   pkg1.rec_nt_1;
   j    NUMBER := 1;
BEGIN
   v2.nt := pkg1.nt_1 (10, 20, 30);
   :v := v2;
   v2.nt.EXTEND;
   v2.nt (4) := 50;
   :v := v2;
END;';
   l_cursor   INTEGER;
   l_ignore   INTEGER;
BEGIN
   l_cursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (l_cursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (l_cursor, ':v', v1);
   l_ignore := DBMS_SQL.execute (l_cursor);
   DBMS_SQL.variable_value_pkg (l_cursor, ':v', v1);
   DBMS_SQL.close_cursor (l_cursor);
   v1.nt.EXTEND;
   v1.nt (5) := 40;

   LOOP
      DBMS_OUTPUT.put_line (v1.nt (j));
      EXIT WHEN v1.nt.NEXT (j) IS NULL;
      j := v1.nt.NEXT (j);
   END LOOP;
END;
/