cl scr
alter session set plsql_warnings = 'enable:all';


create or replace procedure p authid definer as
begin
  dbms_output.put_line ( 'test' );
  raise zero_divide;
exception
  when others then 
    null;
end p;
/

sho err

create or replace procedure log_error authid definer as
begin
  /* 
    ... logging code ...
   */
   
  raise_application_error ( -20001, 'Your error has been logged' );
  
end log_error;
/
sho err

create or replace procedure p authid definer as
begin
  dbms_output.put_line ( 'test' );
  raise zero_divide;
exception
  when others then 
    log_error;
end p;
/
sho err


exec p();





/* The pragma DOESN'T go in the unit with the others handler 
   Doing so raises PLW-06029: PRAGMA SUPPRESSES_WARNING_6009 on LOG_ERROR is misplaced
   */
create or replace procedure p authid definer as
  pragma suppresses_warning_6009 ( log_error );
begin
  dbms_output.put_line ( 'test' );
  raise zero_divide;
exception
  when others then 
    log_error;
end p;
/
sho err



create or replace procedure log_error authid definer as
  pragma suppresses_warning_6009 ( log_error );
begin
  /* Logging */
  raise_application_error ( -20001, 'Your error has been logged' );
end log_error;
/
sho err

create or replace procedure p authid definer as
begin
  dbms_output.put_line ( 'test' );
  raise zero_divide;
exception
  when others then 
    log_error;
end p;
/
sho err

exec p();