CREATE OR REPLACE PACKAGE BODY alert_email_mgr
IS
   PROCEDURE send_email (to_in        IN VARCHAR2,
                         subject_in   IN VARCHAR2,
                         body_in      IN CLOB)
   IS
      l_vc_text   VARCHAR2(32767) := 'Ignore this plain text.';
      l_vc_html   VARCHAR2(32767) := body_in;

      PROCEDURE prepare_apex
      IS
         l_app_id           NUMBER;
         l_workspace_name   alert_config.apex_workspace_name%TYPE;
         c_page    CONSTANT PLS_INTEGER := 1;
         l_cgivar_name      OWA.vc_arr;
         l_cgivar_val       OWA.vc_arr;
      BEGIN
         SELECT apex_workspace_name
           INTO l_workspace_name
           FROM alert_config ac;

         APEX_UTIL.set_workspace (l_workspace_name);
      END;
   BEGIN
      prepare_apex;

      apex_mail.send (p_to          => to_in,
                      p_from        => 'noreply@oracle.com',
                      p_subj        => subject_in,
                      p_body        => l_vc_html,
                      p_body_html   => l_vc_html);

      alert_mgr.LOG (
         'Email sent to ' || to_in || ' with subject ' || subject_in || ' and body '||l_vc_html);
   EXCEPTION
      WHEN OTHERS
      THEN
         alert_mgr.LOG (
               'Unable to send email to '
            || to_in
            || ' with error '
            || DBMS_UTILITY.format_error_stack);
   END;
END;
/