begin
   alert_mgr.register_alert (
      alert_name_in             => 'NEW SHORTAGE REPORTED',
      description_in            => 'Notify registered users if there is a new request for the selected UPC',
      trigger_code_in           => 
         'select 1 from whoeop_shortages
 where created > nvl((select max(created) from whoeop_alert_log),(select min(created) from whoeop_alert_registrations))',
      trigger_type_in           => 'MULTROWS',
      check_frequency_in        => '10',
      recurrence_frequency_in   => '10',
      ignore_failures_in        => 'Y',
      action_type_in            => 'PROC',
      action_code_in            => 'whoeop_alert_util.new_upc_requests',
      is_active_in              => 'Y');
end;
/

select question_id
from qdb_questions where created_on > (select nvl (max (created_on), date ''2020-01-01'') from 

create or replace procedure whoeop_notify_of_shortages
is
begin

for c1 in (
   select id, username, 
          upc, (select description
                  from whoeop_upc_lookup
                 where r.upc = upc) upc_desc,
          created,
          (select max(created) from whoeop_alert_log
            where alert_id = r.id) last_alert
     from whoeop_alert_registrations r -- user/upc combo, send new alert for THAT upc to all people if not already done.
    where active_yn = 'Y'
) loop
   -- any new requests since last alert sent (or alert created if new)
   for c2 in (
      select count(*) cnt
        from whoeop_shortages s
       where created > nvl(c1.last_alert,c1.created)
         and exists (select 1 from whoeop_shortage_details
                      where shortage_id = s.id
                        and upc = c1.upc)
   ) loop
      if c2.cnt > 0 then
         -- send alert
         for c3 in (
            select workspace_id
              from apex_applications
             where application_id = l_app_id
         ) loop
            apex_util.set_security_group_id(p_security_group_id => c3.workspace_id);
         end loop;

/*
         l_actions(1).action_type := 'PROC';
         l_actions(1).action_code := 'alert_mgr.log(????)';
         l_actions(2).action_type := 'PROC';
         l_actions(2).action_code := apex_mail.send (
            p_to                 => c1.username,
            p_template_static_id => 'UPC_ALERT',
            p_placeholders       => '{' ||
               '    "UPC_LINK":'     || apex_json.stringify( l_app_path||'/f?p='||l_app_id||':300:0::::IR_UPC:'||c1.upc ) ||
               '   ,"APP_NAME":'     || apex_json.stringify( 'Shortage Reporting' ) ||
               '   ,"UPC":'          || apex_json.stringify( c1.upc ) ||
               '   ,"UPC_DESC":'     || apex_json.stringify( c1.upc_desc ) ||
               '   ,"NBR_REQUESTS":' || apex_json.stringify( to_char(c2.cnt,'999G999G999G999G999G999G990' ) ||
               '   ,"SUBJECT":'      || apex_json.stringify( 'Shortage Reporting: Request for '||c1.upc ) ||
               '}' );
         l_actions(3).action_type := 'PROC';
         l_actions(3).action_code := 'whoeop_alert_util.alert_sent(p_alert_id => '||c1.id||)';
*/
      end if;
   end loop;
end loop;

end;
/