CREATE TABLE dd_species
(
   species_name             VARCHAR2 (200),
   eats_dinosaurs           VARCHAR2 (1),
   average_length_in_feet   NUMBER,
   average_weight_in_tons   NUMBER
)
/

CREATE TABLE dd_members
(
   member_name     VARCHAR2 (200),
   species_name    VARCHAR2 (200),
   member_status   VARCHAR2 (1)
)
/

BEGIN
   INSERT INTO dd_species (species_name,
                           eats_dinosaurs,
                           average_length_in_feet,
                           average_weight_in_tons)
        VALUES ('Stegosaurus',
                0,
                -23,
                0);

   INSERT INTO dd_members (member_name, species_name, member_status)
        VALUES ('Sally Stego', 'Stegasaurus', 'X');


   INSERT INTO dd_members (member_name, species_name, member_status)
        VALUES ('Terry Dactyl', NULL, 'X');

   COMMIT;
END;
/

/* Take two */

DROP TABLE dd_species
/

DROP TABLE dd_members
/


CREATE TABLE dd_species
(
   species_id               NUMBER GENERATED ALWAYS AS IDENTITY PRIMARY KEY,
   species_name             VARCHAR2 (200) UNIQUE,
   eats_dinosaurs           VARCHAR2 (1) CHECK (eats_dinosaurs IN ('Y', 'N')),
   average_length_in_feet   NUMBER CHECK (average_length_in_feet > 0),
   average_weight_in_tons   NUMBER CHECK (average_weight_in_tons > 0)
)
/

CREATE TABLE dd_members
(
   member_id       NUMBER GENERATED ALWAYS AS IDENTITY PRIMARY KEY,
   species_id      NUMBER REFERENCES dd_species (species_id),
   member_name     VARCHAR2 (200),
   member_status   VARCHAR2 (1) CHECK (member_status IN ('G', 'P', 'V'))
)
/

INSERT INTO dd_species (species_name,
                        eats_dinosaurs,
                        average_length_in_feet,
                        average_weight_in_tons)
     VALUES ('Stegosaurus',
             0,
             -23,
             0)
/

INSERT INTO dd_species (species_name,
                        eats_dinosaurs,
                        average_length_in_feet,
                        average_weight_in_tons)
     VALUES ('Stegosaurus',
             'N',
             -23,
             0)
/

INSERT INTO dd_species (species_name,
                        eats_dinosaurs,
                        average_length_in_feet,
                        average_weight_in_tons)
     VALUES ('Stegosaurus',
             'N',
             23,
             0)
/

INSERT INTO dd_species (species_name,
                        eats_dinosaurs,
                        average_length_in_feet,
                        average_weight_in_tons)
     VALUES ('Stegosaurus',
             'N',
             23,
             2)
/

INSERT INTO dd_members (member_name, species_id, member_status)
     VALUES ('Sally Stego', 'Stegasaurus', 'X')
/


INSERT INTO dd_members (member_name, species_name, member_status)
     VALUES ('Terry Dactyl', NULL, 'X')
/

/* Give constraints a name */

ALTER TABLE dd_species
ADD CONSTRAINT eats_dinosaurs_yn
  CHECK (eats_dinosaurs IN ('Y', 'N'))
/  