CREATE OR REPLACE PACKAGE tmr
IS
   PROCEDURE start_timer;

   PROCEDURE show_elapsed_time (message_in IN VARCHAR2 := NULL);
END tmr;
/

CREATE OR REPLACE PACKAGE BODY tmr
IS
   last_timing   integer;

   PROCEDURE start_timer
   IS
   BEGIN
      last_timing := dbms_utility.get_cpu_time;
   END;

   PROCEDURE show_elapsed_time (message_in IN VARCHAR2 := NULL)
   IS
   BEGIN
      DBMS_OUTPUT.put_line (
            CASE
               WHEN message_in IS NULL THEN 'Completed in:'
               ELSE '"' || message_in || '" completed in: '
            END
         || to_char (dbms_utility.get_cpu_time - last_timing)
         || ' centiseconds');

      /* Reset timer */
      start_timer;
   END;
END tmr;
/

CREATE OR REPLACE FUNCTION lotsa_default_values (
   count_in IN INTEGER default dbms_random.value(1,10),
   date_in in date default add_months (sysdate, 3),
   string_in in varchar2 default substr (user, 1, 3),
   
   count_in2 IN INTEGER default dbms_random.value(1,10),
   date_in2 in date default add_months (sysdate, 3),
   string_in2 in varchar2 default substr (user, 1, 3),
   
   count_in3 IN INTEGER default dbms_random.value(1,10),
   date_in3 in date default add_months (sysdate, 3),
   string_in3 in varchar2 default substr (user, 1, 3),
   
   count_in4 IN INTEGER default dbms_random.value(1,10),
   date_in4 in date default add_months (sysdate, 3),
   string_in4 in varchar2 default substr (user, 1, 3))
   RETURN NUMBER
IS
BEGIN
   RETURN count_in + to_char (date_in, 'YYYY') + length (string_in);
END;
/

declare
i integer;
begin
tmr.start_timer;
for indx in 1 .. 100000 loop
i := i + lotsa_default_values();
end loop;
dbms_output.put_line (i);
tmr.show_elapsed_time ('all defaults');
end;
/

declare
i integer;
begin
tmr.start_timer;
for indx in 1 .. 100000 loop
i := i + lotsa_default_values(  dbms_random.value(1,10),
   add_months (sysdate, 3),
   substr (user, 1, 3),
     dbms_random.value(1,10),
   add_months (sysdate, 3),
   substr (user, 1, 3),
     dbms_random.value(1,10),
   add_months (sysdate, 3),
   substr (user, 1, 3)
   );
end loop;
dbms_output.put_line (i);
tmr.show_elapsed_time ('no defaults');
end;
/