declare
   l_name varchar2(100) := null;
begin
   if to_char (sysdate, 'D') = 1
   then
      l_name := 'Hard Worker';
   end if;

   dbms_output.put_line (l_name);
end;
/

declare
   cursor c is select last_name from employees;
   l_names dbms_sql.varchar2_table;
begin
   open c;
   loop
      l_names.delete;
      fetch c bulk collect into l_names limit 10;
   end loop;
   close c;
end;
/

declare
   cursor c is select last_name from employees;
   l_names dbms_sql.varchar2_table;
begin
   open c;
   loop
      fetch c bulk collect into l_names limit 10;
      
      for indx in l_names.first .. l_names.last
      loop
         dbms_output.put_line (l_names (indx));
      end loop;
   end loop;
   close c;
end;
/

declare
   cursor c is select last_name from employees;
   l_names dbms_sql.varchar2_table;
   indx pls_integer;
begin
   open c;
   loop
      fetch c bulk collect into l_names limit 10;
      
      for indx in 1 .. l_names.count
      loop
         dbms_output.put_line (l_names (indx));
      end loop;
   end loop;
end;
/

declare
   just_the_date date := trunc (date '2021-01-01');
begin
   dbms_output.put_line (just_the_date);
end;
/

create or replace procedure display_first_10 (p_name in varchar2)
is
   l_name varchar2(100);
begin
   if p_name is null
   then
      l_name := null;
   else
      l_name := substr (p_name, 1, 10);
   end if;
   
   dbms_output.put_line (l_name);
end;   
/

create or replace procedure show_dept_total (p_department_id in number)
is
   l_total number;
begin
   select nvl (sum (salary), 0) into l_total
     from employees
    where department_id = p_department_id;
   
   dbms_output.put_line (l_total);
exception
   when no_data_found
   then
      dbms_output.put_line (0);
end;
/
     
begin
   execute immediate 'alter table employees add favorite_color varchar2';
   commit;
end;
/ 

select last_name the_name from employees
union
select department_name from departments
order by the_name
/
     
begin
   do_a_bunch_of_stuff;
exception 
   when others
   then
      if sqlcode > 0
      then
         log_error;
      end if;
end;
/ 
     
declare
   cursor c is select * from employees;
begin
   open c;
   
   for rec in c
   loop
      dbms_output.put_line (rec.last_name);
   end loop;
   close c;
end;
/ 



