DECLARE
   PROCEDURE move_them_to (actions_in IN VARCHAR2, cat_in IN VARCHAR2)
   IS
   BEGIN
      EXECUTE IMMEDIATE
            'update public_action set action_category_id = 
                     (select id 
                        from public_action_category 
                       where ACTION_CATEGORY_CODE = :cat)
              where id in (' || actions_in || ')'
         USING cat_in;
   END;

   PROCEDURE add_one (cat_in       IN VARCHAR2,
                      NAME_IN      IN VARCHAR2,
                      details_in   IN VARCHAR2,
                      example_in   IN VARCHAR2 DEFAULT NULL,
                      url_in       IN VARCHAR2)
   IS
   BEGIN
      INSERT INTO public_action (action_category_id,
                                 action_name,
                                 details,
                                 example,
                                 public_yn,
                                 url,
                                 vip_yn,
                                 rejected_yn,
                                 from_name,
                                 from_email)
         SELECT id,
                NAME_IN,
                details_in,
                example_in,
                'Y',
                url_in,
                'N',
                'N',
                'Steven Feuerstein',
                'steven@stevenfeuerstin.com'
           FROM public_action_category
          WHERE public_action_code = cat_in;
   END;
BEGIN
   move_them_to ('10,33', 'PERSONAL_CARE');
   move_them_to ('5,25,26,61', 'HOME');
   move_them_to ('6,28,21', 'WORK');
   move_them_to ('4,31', 'GARDENING');
   move_them_to ('2,7,12,29,31,24', 'SHOPPING');
   move_them_to ('1,20,18,19', 'TRANSPORT');
   move_them_to ('9,14,16,3,8,15,17,30', 'FOOD');

   /* disable old categories */
   UPDATE public_action_category
      SET active_yn = 'N'
    WHERE action_category_code NOT IN ('VACATION',
                                       'FITNESS',
                                       'OUTDOOR_ENTERTAINMENT',
                                       'INDOOR_ENTERTAINMENT',
                                       'PARENTING',
                                       'ELECTRONICS',
                                       'TRAVEL',
                                       'PERSONAL_CARE',
                                       'HOME',
                                       'WORK',
                                       'GARDENING',
                                       'SHOPPING',
                                       'FOOD',
                                       'TRANSPORT',
                                       'HOBBIES',
                                       'HEAL_PLANET');
/*
Nothing in these yet
move_them_to ('1', 'VACATION');
move_them_to ('1', 'FITNESS');
move_them_to ('1', 'OUTDOOR_ENTERTAINMENT');
move_them_to ('1', 'INDOOR_ENTERTAINMENT');
move_them_to ('1', 'PARENTING');
move_them_to ('1', 'ELECTRONICS');
move_them_to ('1', 'TRAVEL');
move_them_to ('1', 'HOBBIES');
*/

/* What to do with...

   give clothes second life 27
   broke, fix it 32
   11 - hide - don't buy to satisfy desire
*/
END;