DECLARE
   FUNCTION daynum_to_abbrev (daynum_in IN INTEGER)
      RETURN VARCHAR2
   IS
   BEGIN
      RETURN CASE daynum_in
                WHEN 1 THEN 'SUN'
                WHEN 2 THEN 'MON'
                WHEN 3 THEN 'TUE'
                WHEN 4 THEN 'WED'
                WHEN 5 THEN 'THU'
                WHEN 6 THEN 'FRI'
                WHEN 7 THEN 'SAT'
             END;
   END;

   PROCEDURE gen_freq (f_in        IN VARCHAR2,
                       time_in     IN NUMBER,
                       daynum_in   IN INTEGER,
                       nth_in      IN INTEGER)
   IS
      l_next_ts   TIMESTAMP;
      l_string    VARCHAR2 (1200);
   BEGIN
    DBMS_OUTPUT.put_line (
               f_in        ||'-'||
                       time_in ||'-'||
                       daynum_in   ||'-'||
                       nth_in );
               
      CASE f_in
         WHEN 'W'
         THEN
            /* Day number and class time - hour offset
            */
            l_string :=
                  'FREQ=WEEKLY;BYHOUR='
               || time_in
               || ';BYDAY='
               || daynum_to_abbrev (daynum_in);
         WHEN 'M'
         THEN
            l_string :=
                  'FREQ=MONTHLY;BYHOUR='
               || time_in
               || ';BYDAY='
               || nth_in
               || daynum_to_abbrev (daynum_in);
            DBMS_OUTPUT.put_line (l_string);
            DBMS_SCHEDULER.evaluate_calendar_string (l_string,
                                                     SYSTIMESTAMP,
                                                     NULL,
                                                     l_next_ts);
            DBMS_OUTPUT.put_line (
               TO_CHAR (CAST (l_next_ts AS DATE), 'YYYY-MM-DD HH24:MI:SS'));
      END CASE;
   END;
BEGIN
   gen_freq ('W',
             10.5,
             1,
             NULL);
   gen_freq ('W',
             14,
             4,
             NULL);
   gen_freq ('M',
             8,
             3,
             2);
   gen_freq ('M',
             15,
             6,
             4);
EXCEPTION
   WHEN OTHERS
   THEN
      DBMS_OUTPUT.put_line (SQLERRM);
END;