CREATE OR REPLACE PACKAGE my_globals
IS
   g_fav_language   VARCHAR2 (6) := 'PL/SQL';

   PROCEDURE show_fav_languages;
END;
/

CREATE OR REPLACE PACKAGE BODY my_globals
IS
   PROCEDURE show_fav_languages
   IS
      l_fav_language   VARCHAR2 (6) := 'SQL';
   BEGIN
      DBMS_OUTPUT.put_line ('* Local favorite language ' || l_fav_language);
      DBMS_OUTPUT.put_line (
         '* Global favorite language ' || my_globals.g_fav_language);
   END;
END;
/

BEGIN
   DBMS_OUTPUT.PUT_LINE ('Initial values');
   my_globals.show_fav_languages;
   DBMS_OUTPUT.PUT_LINE ('Global value changed');
   my_globals.g_fav_language := 'SQL';
   my_globals.show_fav_languages;
END;
/

BEGIN
   DBMS_OUTPUT.PUT_LINE ('New block same session');
   my_globals.show_fav_languages;
END;
/

/*
Initial values
* Local favorite language SQL
* Global favorite language PL/SQL
Global value changed
* Local favorite language SQL
* Global favorite language SQL
New block same session
* Local favorite language SQL
* Global favorite language SQL
*/