/* Before */

CREATE OR REPLACE PACKAGE BODY dd_admin_pkg
IS
   PROCEDURE broadcast_message_big (
      from_member_id_p   IN INTEGER,
      subject_p          IN VARCHAR2,
      message_in         IN VARCHAR2,
      fetch_limit_in     IN INTEGER DEFAULT 100)
   IS
      failure_in_forall   EXCEPTION;
      PRAGMA EXCEPTION_INIT (failure_in_forall, -24381);

      TYPE members_t IS TABLE OF dd_members%ROWTYPE;

      l_members           members_t;

      CURSOR members_cur
      IS
         SELECT * FROM dd_members;

      l_scope             logger_logs.scope%TYPE := 'broadcast_message_big';
      l_params            logger.tab_param;
   BEGIN
      logger.append_param (l_params, 'from_member_id_p', from_member_id_p);
      logger.append_param (l_params, 'subject_p', subject_p);
      logger.append_param (l_params, 'message_in', message_in);
      logger.append_param (l_params, 'fetch_limit_in', fetch_limit_in);

      logger.LOG ('START',
                  l_scope,
                  NULL,
                  l_params);

      OPEN members_cur;

      LOOP
         FETCH members_cur BULK COLLECT INTO l_members LIMIT fetch_limit_in;

         BEGIN
            FORALL indx IN 1 .. l_members.COUNT SAVE EXCEPTIONS
               INSERT INTO dd_messages (from_member_id,
                                        to_member_id,
                                        subject,
                                        message_contents)
                    VALUES (from_member_id_p,
                            l_members (indx).member_id,
                            subject_p,
                            message_in);
         END;
      END LOOP;

      CLOSE members_cur;
   END;
END dd_admin_pkg;
/

CREATE OR REPLACE PACKAGE BODY dd_admin_pkg
IS
   PROCEDURE broadcast_message_big (
      from_member_id_p   IN INTEGER,
      subject_p          IN VARCHAR2,
      message_in         IN VARCHAR2,
      fetch_limit_in     IN INTEGER DEFAULT 100)
   IS
      failure_in_forall   EXCEPTION;
      PRAGMA EXCEPTION_INIT (failure_in_forall, -24381);

      TYPE members_t IS TABLE OF dd_members%ROWTYPE;

      l_members           members_t;

      CURSOR members_cur
      IS
         SELECT * FROM dd_members;

      PROCEDURE initialize
      IS
         l_scope    logger_logs.scope%TYPE := 'broadcast_message_big';
         l_params   logger.tab_param;
      BEGIN
         logger.append_param (l_params, 'from_member_id_p', from_member_id_p);
         logger.append_param (l_params, 'subject_p', subject_p);
         logger.append_param (l_params, 'message_in', message_in);
         logger.append_param (l_params, 'fetch_limit_in', fetch_limit_in);
         logger.LOG ('START',
                     l_scope,
                     NULL,
                     l_params);

         OPEN members_cur;
      END;
   BEGIN
      initialize;

      LOOP
         FETCH members_cur BULK COLLECT INTO l_members LIMIT fetch_limit_in;

         BEGIN
            FORALL indx IN 1 .. l_members.COUNT SAVE EXCEPTIONS
               INSERT INTO dd_messages (from_member_id,
                                        to_member_id,
                                        subject,
                                        message_contents)
                    VALUES (from_member_id_p,
                            l_members (indx).member_id,
                            subject_p,
                            message_in);
         END;
      END LOOP;

      CLOSE members_cur;
   END;
END dd_admin_pkg;
/