create or replace package p authid definer
is
   c_prefix    constant char (1) := chr (8);
   c_linelen   constant integer := 80;

   /* Toggles output from p.l */
   procedure turn_on;

   procedure turn_off;

   /* Specification of Set/Get for "linesep" */
   procedure set_linesep (linesep_in in varchar2);

   function linesep
      return varchar2;

   /* Specification of Set/Get for "prefix" */
   procedure set_prefix (prefix_in in varchar2 := c_prefix);

   function prefix
      return varchar2;

   /* Set line length before wrap */
   procedure set_linelen (len in integer := c_linelen);

   function linelen
      return integer;

   /* The overloaded versions of the p.l procedure */

   /* Display a date. Can specify a format mask or use the default. */
   procedure l (dt        in date,
                mask_in   in varchar2 := null,
                show_in   in boolean := false);

   /* Display a number. */
   procedure l (num in number, show_in in boolean := false);

   /* Display a string. */
   procedure l (stg in varchar2, show_in in boolean := false);

   /* Display a string followed by a number. */
   procedure l (stg in varchar2, num in number, show_in in boolean := false);

   /* Display a string followed by a date. */
   procedure l (stg       in varchar2,
                dt        in date,
                mask_in   in varchar2 := null,
                show_in   in boolean := false);

   /* Display a Boolean value. */
   procedure l (bool in boolean, show_in in boolean := false);

   /* Display a string and then a Boolean value. */
   procedure l (stg       in varchar2,
                bool      in boolean,
                show_in   in boolean := false);

   procedure l (file_in in utl_file.file_type, show_in in boolean := false);

   procedure l (string_in   in varchar2,
                file_in     in utl_file.file_type,
                show_in     in boolean := false);

   /* Additional overloadings */
   procedure l (num1 in number, num2 in number, show_in in boolean := false);

   procedure l (str       in varchar2,
                num1      in number,
                num2      in number,
                show_in   in boolean := false);

   procedure l (bool1     in boolean,
                bool2     in boolean,
                show_in   in boolean := false);

   procedure l (stg1      in varchar2,
                stg2      in varchar2,
                show_in   in boolean := false);

   procedure l (dt1       in date,
                dt2       in date,
                mask_in   in varchar2 := null,
                show_in   in boolean := false);

   procedure l (num       in number,
                dt        in date,
                mask_in   in varchar2 := null,
                show_in   in boolean := false);

   procedure l (bool in boolean, num in number, show_in in boolean := false);

   procedure l (bool      in boolean,
                dt        in date,
                mask_in   in varchar2 := null,
                show_in   in boolean := false);

   procedure l (bool      in boolean,
                stg       in varchar2,
                show_in   in boolean := false);
end p;
/

REM SHOW ERRors