CREATE OR REPLACE PROCEDURE proc1
IS
BEGIN
   DBMS_OUTPUT.put_line ($$plsql_unit);
END;
/

BEGIN
   proc1 ();
END;
/

CREATE OR REPLACE PACKAGE pkg
IS
   PROCEDURE proc;
END;
/

CREATE OR REPLACE PACKAGE BODY pkg
IS
   PROCEDURE proc
   IS
   BEGIN
      DBMS_OUTPUT.put_line ($$plsql_unit);
   END;
END;
/

BEGIN
   pkg.proc ();
END;
/

CREATE OR REPLACE PROCEDURE proc2
IS
   PROCEDURE proc_nested
   IS
   BEGIN
      DBMS_OUTPUT.put_line ($$plsql_unit);
   END;
BEGIN
   proc_nested;
END;
/

BEGIN
   proc2 ();
END;
/

CREATE OR REPLACE TYPE an_object_type IS OBJECT
(
   n NUMBER,
   STATIC PROCEDURE proc_method
)
/

CREATE OR REPLACE TYPE BODY an_object_type
IS
   STATIC PROCEDURE proc_method
   IS
   BEGIN
      DBMS_OUTPUT.put_line ($$plsql_unit);
   END;
END;
/

BEGIN
   an_object_type.proc_method ();
END;
/

CREATE OR REPLACE PROCEDURE proc3
IS
BEGIN
   EXECUTE IMMEDIATE 'begin proc1; end;';
END;
/

BEGIN
   proc3;
END;
/


/* Clean up */

DROP PROCEDURE proc1
/

DROP PROCEDURE proc2
/

DROP PROCEDURE proc3
/

DROP PACKAGE pkg
/

DROP TYPE an_object_type
/