CREATE TABLE employees
AS
   SELECT * FROM hr.employees
/

ALTER SESSION SET PLSQL_WARNINGS = 'ENABLE:ALL'
/

CREATE OR REPLACE PACKAGE pkg
IS
   TYPE collection_t IS TABLE OF VARCHAR2 (100);

   PROCEDURE proc (collection_io IN OUT collection_t);
END;
/

CREATE OR REPLACE PACKAGE BODY pkg
IS
   PROCEDURE proc (collection_io IN OUT collection_t)
   IS
   BEGIN
      DBMS_OUTPUT.PUT_LINE ('Hello!');
   END proc;

   PROCEDURE funny_names
   IS
      INTEGER   NUMBER;

      PROCEDURE TO_CHAR
      IS
      BEGIN
         INTEGER := 10;
      END TO_CHAR;
   BEGIN
      TO_CHAR;
   END;

   FUNCTION interesting_info (check_in IN BOOLEAN)
      RETURN VARCHAR2
   AS
      FUNCTION my_function
         RETURN BOOLEAN
      IS
      BEGIN
         RETURN check_in AND NOT check_in;
      END;

      FUNCTION my_date
         RETURN DATE
      IS
      BEGIN
         RETURN SYSDATE - 10;
      END;
   BEGIN
      IF check_in
      THEN
         RETURN 'abc';
      ELSE
         IF my_function ()
         THEN
            RETURN 'What a string!';
         ELSIF SYSDATE < my_date ()
         THEN
            RETURN 'qrs';
         ELSE
            DBMS_OUTPUT.put_line ('Hello!');
         END IF;
      END IF;
   END;

   PROCEDURE hidden_mysteries
   IS
      l_checking   BOOLEAN := FALSE;

      PROCEDURE why_did_i_write_this
      IS
      BEGIN
         DBMS_OUTPUT.put_line ('Why did I write this?');
      END;
   BEGIN
      NULL;

      IF l_checking
      THEN
         DBMS_OUTPUT.put_line ('Never here...');
      ELSE
         DBMS_OUTPUT.put_line ('Always here...');
         GOTO end_of_function;
      END IF;

     <<end_of_function>>
      NULL;
   END;

   FUNCTION return_info
      RETURN VARCHAR2
   AS
      PROCEDURE raise_in_here
      AS
      BEGIN
         RAISE PROGRAM_ERROR;
      END raise_in_here;
   BEGIN
      RETURN 'abc';
   EXCEPTION
      WHEN OTHERS
      THEN
         raise_in_here;
         RETURN NULL;
   END;

   FUNCTION messy_messy
      RETURN PLS_INTEGER
   AS
      l_count   PLS_INTEGER;
   BEGIN
      SELECT COUNT (*)
        INTO l_count
        FROM employees
       WHERE salary = '10000';

      RETURN l_count;
   END;

   PROCEDURE old_code_gathers
   IS
      n   NUMBER;
      m   NUMBER := 100;
      s   VARCHAR2 (5);
   BEGIN
      DBMS_OUTPUT.put_line ('New code here');
   END;

   PROCEDURE all_code_has_bugs_but
   IS
      l_var1   CHAR (1) := 'abc';
      l_var2   VARCHAR2 (1) := 'abc';
      l_var3   NUMBER := 1 / 0;
   BEGIN
      DBMS_OUTPUT.put_line ('This is ridiculous.');
   END;
BEGIN
   funny_names;
   hidden_mysteries;
   old_code_gathers;
   all_code_has_bugs_but;

   IF messy_messy > 0
   THEN
      DBMS_OUTPUT.put_line ('called');
   END IF;

   IF return_info IS NOT NULL
   THEN
      DBMS_OUTPUT.put_line ('called');
   END IF;

   IF interesting_info (FALSE) IS NOT NULL
   THEN
      DBMS_OUTPUT.put_line ('called');
   END IF;

   IF interesting_info (TRUE) IS NOT NULL
   THEN
      DBMS_OUTPUT.put_line ('called again');
   END IF;
END;
/

  SELECT *
    FROM user_errors
   WHERE name = 'PKG'
ORDER BY text
/

  SELECT *
    FROM user_errors
   WHERE name = 'PKG'
ORDER BY line
/